using Indotalent.Data.Entities;
using Indotalent.Shared.Consts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Indotalent.Infrastructure.Database.MsSQL.Configuration;

public class BookingResourceConfiguration : IEntityTypeConfiguration<BookingResource>
{
    public void Configure(EntityTypeBuilder<BookingResource> builder)
    {
        builder.Property(e => e.Name)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Description)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.BookingGroupId)
            .HasMaxLength(GlobalConsts.StringLengthId);

        builder.HasOne(e => e.BookingGroup)
            .WithMany()
            .HasForeignKey(e => e.BookingGroupId)
            .OnDelete(DeleteBehavior.NoAction);

        builder.HasIndex(e => new { e.TenantId, e.Name }).IsUnique();
        builder.HasIndex(e => e.BookingGroupId);
    }
}